<?php
class ControllerBrowntapeOrder extends Controller {
    private $debug = false;
    private $message = "Api Key Not Match or disabled the browntape extenstion";
    public function _getProduct() {
        $this->load->model('browntape/order');
        $this->load->model('tool/image');
        $json = array(
            'success' => true,
            'product' => array()
        );
        # -- $_GET params ------------------------------
        if (isset($this->request->get['id'])) {
            $product_id = $this->request->get['id'];
        } else {
            $product_id = 0;
        }
        $checkApiKey = $this->model_browntape_order->checkApiKey($this->request->get['apikey']);
        if ($checkApiKey) {
            $product = $this->model_browntape_order->getProduct($product_id);
            #minimum
            if ($product['minimum']) {
                $minimum = $product['minimum'];
            } else {
                $minimum = 1;
            }
            if (!empty($product)) {
                $json['product'] = array(
                    'id' => $product['product_id'],
                    'name' => $product['name'],
                    'tag' => $product['tag'],
                    'model' => $product['model'],
                    'sku' => $product['sku'],
                    'upc' => $product['upc'],
                    'ean' => $product['ean'],
                    'jan' => $product['jan'],
                    'isbn' => $product['isbn'],
                    'mpn' => $product['mpn'],
                    'location' => $product['location'],
                    'quantity' => $product['quantity'],
                    'stock_status' => $product['stock_status'],
                    'manufacturer_id' => $product['manufacturer_id'],
                    'manufacturer' => $product['manufacturer'],
                    'price' => $product['price'],
                    'reward' => $product['reward'],
                    'points' => $product['points'],
                    'tax_class_id' => $product['tax_class_id'],
                    'date_available' => $product['date_available'],
                    'weight' => $product['weight'],
                    'weight_class_id' => $product['weight_class_id'],
                    'length' => $product['length'],
                    'width' => $product['width'],
                    'height' => $product['height'],
                    'length_class_id' => $product['length_class_id'],
                    'subtract' => $product['subtract'],
                    'rating' => (int) $product['rating'],
                    'reviews' => (int) $product['reviews'],
                    'minimum' => $minimum,
                    'sort_order' => $product['sort_order'],
                    'status' => $product['status'],
                    'date_added' => $product['date_added'],
                    'date_modified' => $product['date_modified'],
                    'viewed' => $product['viewed'],
                    'product_option' => $product['product_option']
                );
            }
            $this->response->setOutput(json_encode($json));
        } else {
            $json = array(
                'success' => true,
                'Error' => array(
                    $this->message
                )
            );
            $this->response->setOutput(json_encode($json));
        }
    }
    public function _getProductlist() {
        $this->load->model('browntape/order');
        $this->load->model('tool/image');
        $json = array(
            'success' => true,
            'productcount' => 0,
            'products' => array()
        );
        # -- $_GET params ------------------------------
        if (isset($this->request->get['startDate'])) {
            $startDate = $this->request->get['startDate'];
        } else {
            $startDate = null;
        }
        $page=null;
        if (isset($this->request->get['page'])) {
            $page = $this->request->get['page'];
        } 
        # -- End $_GET params --------------------------
        $checkApiKey = $this->model_browntape_order->checkApiKey($this->request->get['apikey']);
        # -- End $_GET params --------------------------
        if ($checkApiKey) {
            $products = $this->model_browntape_order->getProducts(array(
                'startDate' => $startDate,
                 'page'=>$page
            ));
            foreach ($products as $product) {
                $json['products'][] = array(
                    'id' => $product['product_id'],
                    'name' => $product['name'],
                    'tag' => $product['tag'],
                    'model' => $product['model'],
                    'sku' => $product['sku'],
                    'upc' => $product['upc'],
                    'ean' => $product['ean'],
                    'jan' => $product['jan'],
                    'isbn' => $product['isbn'],
                    'mpn' => $product['mpn'],
                    'location' => $product['location'],
                    'quantity' => $product['quantity'],
                    'stock_status' => $product['stock_status'],
                    'manufacturer_id' => $product['manufacturer_id'],
                    'manufacturer' => $product['manufacturer'],
                    'price' => $product['price'],
                    'reward' => $product['reward'],
                    'points' => $product['points'],
                    'tax_class_id' => $product['tax_class_id'],
                    'date_available' => $product['date_available'],
                    'weight' => $product['weight'],
                    'weight_class_id' => $product['weight_class_id'],
                    'length' => $product['length'],
                    'width' => $product['width'],
                    'height' => $product['height'],
                    'length_class_id' => $product['length_class_id'],
                    'subtract' => $product['subtract'],
                    'rating' => (int) $product['rating'],
                    'reviews' => (int) $product['reviews'],
                    'sort_order' => $product['sort_order'],
                    'status' => $product['status'],
                    'date_added' => $product['date_added'],
                    'date_modified' => $product['date_modified'],
                    'viewed' => $product['viewed'],
                    'product_option' => $product['product_option']
                );
            }
            $json['productcount'] = count($json['products']);
            $this->response->setOutput(json_encode($json));
        } else {
            $json = array(
                'success' => true,
                'Error' => array(
                    $this->message
                )
            );
            $this->response->setOutput(json_encode($json));
        }
    }
    public function __call($methodName, $arguments) {
        //call_user_func(array($this, str_replace('.', '_', $methodName)), $arguments);
        call_user_func(array(
            $this,
            "_$methodName"
        ), $arguments);
    }
    public function _getorder() {
        $this->load->model('browntape/order');
        $this->load->model('tool/image');
        $json = array(
            'success' => true,
            'order' => array()
        );
        # -- $_GET params ------------------------------
        if (isset($this->request->get['id'])) {
            $order_id = $this->request->get['id'];
        } else {
            $order_id = 0;
        }
        # -- End $_GET params --------------------------
        $checkApiKey = $this->model_browntape_order->checkApiKey($this->request->get['apikey']);
        
        # -- End $_GET params --------------------------
        if ($checkApiKey) {
            $order = $this->model_browntape_order->getOrder($order_id);
            if (!empty($order)) {
                $json['orders'] = array(
                    'order_id' => $order['order_id'],
                    'invoice_no' => $order['invoice_no'],
                    'invoice_prefix' => $order['invoice_prefix'],
                    'store_id' => $order['store_id'],
                    'store_name' => $order['store_name'],
                    'store_url' => $order['store_url'],
                    'customer_id' => $order['customer_id'],
                    'customer_group_id' => $order['customer_group_id'],
                    'firstname' => $order['firstname'],
                    'lastname' => $order['lastname'],
                    'email' => $order['email'],
                    'telephone' => $order['telephone'],
                    'fax' => $order['fax'],
                    'payment_firstname' => $order['payment_firstname'],
                    'payment_lastname' => $order['payment_lastname'],
                    'payment_company' => $order['payment_company'],
                    'payment_company_id' => @$order['payment_company_id'],
                    'payment_tax_id' => @$order['payment_tax_id'],
                    'payment_address_1' => $order['payment_address_1'],
                    'payment_address_2' => $order['payment_address_2'],
                    'payment_city' => $order['payment_city'],
                    'payment_postcode' => $order['payment_postcode'],
                    'payment_country' => $order['payment_country'],
                    'payment_country_id' => $order['payment_country_id'],
                    'payment_zone' => $order['payment_zone'],
                    'payment_zone_id' => $order['payment_zone_id'],
                    'payment_address_format' => $order['payment_address_format'],
                    'payment_method' => $order['payment_method'],
                    'payment_code' => $order['payment_code'],
                    'shipping_firstname' => $order['shipping_firstname'],
                    'shipping_lastname' => $order['shipping_lastname'],
                    'shipping_company' => $order['shipping_company'],
                    'shipping_address_1' => $order['shipping_address_1'],
                    'shipping_address_2' => $order['shipping_address_2'],
                    'shipping_city' => $order['shipping_city'],
                    'shipping_postcode' => $order['shipping_postcode'],
                    'shipping_country' => $order['shipping_country'],
                    'shipping_country_id' => $order['shipping_country_id'],
                    'shipping_zone' => $order['shipping_zone'],
                    'shipping_zone_id' => $order['shipping_zone_id'],
                    'shipping_address_format' => $order['shipping_address_format'],
                    'shipping_method' => $order['shipping_method'],
                    'shipping_code' => $order['shipping_code'],
                    'comment' => $order['comment'],
                    'total' => $order['total'],
                    'order_status_id' => $order['order_status_id'],
                    'affiliate_id' => $order['affiliate_id'],
                    'commission' => $order['commission'],
                    'language_id' => $order['language_id'],
                    'currency_id' => $order['currency_id'],
                    'currency_code' => $order['currency_code'],
                    'currency_value' => $order['currency_value'],
                    'ip' => $order['ip'],
                    'forwarded_ip' => $order['forwarded_ip'],
                    'user_agent' => $order['user_agent'],
                    'accept_language' => $order['accept_language'],
                    'date_added' => $order['date_added'],
                    'date_modified' => $order['date_modified'],
                    'shipping_fee' => $order['shipping_fee'],
		'cod_fee' => $order['cod_fee']
                );
                if (!empty($order['item'])) {
                    foreach ($order['item'] as $key => $item) {
                        $json['orders']['item'][$key] = $item;
                    }
                }
            }
            $this->response->setOutput(json_encode($json, true));
        } else {
            $json = array(
                'success' => true,
                'Error' => array(
                    $this->message
                )
            );
            $this->response->setOutput(json_encode($json));
        }
    }
    /*this function update order status */
    public function _markAsShipped() {
        $errors = array();
        $this->load->model('browntape/order');
        $this->load->model('tool/image');
        $json = array(
            'success' => true
        );
        # -- $_GET params ------------------------------
        if (!empty($this->request->get['order_id'])) {
            $order_id = $this->request->get['order_id'];
        } else {
            $errors = array_merge($errors, array(
                'order_id' => 'order id  Required'
            ));
        }
        if (!empty($this->request->get['shippingMethod'])) {
            $courierName = $this->request->get['shippingMethod'];
        } else {
            $errors = array_merge($errors, array(
                'shippingMethod' => 'shippingMethod  Required'
            ));
        }
        if (!empty($this->request->get['awbNo'])) {
            $awbNo = $this->request->get['awbNo'];
        } else {
            $errors = array_merge($errors, array(
                'awbNo' => 'awb No Required'
            ));
        }
        $checkApiKey = $this->model_browntape_order->checkApiKey($this->request->get['apikey']);
        # -- End $_GET params --------------------------
        if ($checkApiKey) {
            if (empty($errors)) {
                $status = $this->model_browntape_order->updateOrderStatus($order_id, 3, $courierName, $awbNo);
                if ($status == 1) {
                    $json['status'] = array(
                        'order_status' => 'shipped'
                    );
                } else {
                    $json = array(
                        'success' => true,
                        'Error' => 'order id not found',
                        'order_status' => ''
                    );
                }
                $this->response->setOutput(json_encode($json, true));
            } else {
                $json = array(
                    'success' => true,
                    'Error' => $errors
                );
                $this->response->setOutput(json_encode($json, true));
            }
        } else {
            $json = array(
                'success' => true,
                'Error' => array(
                    $this->message
                )
            );
            $this->response->setOutput(json_encode($json));
        }
    }
    /*this function cancel order  */
    public function _markAsCancelled() {
        $this->load->model('browntape/order');
        $this->load->model('tool/image');
        $json = array(
            'success' => true
        );
        # -- $_GET params ------------------------------
        if (isset($this->request->get['order_id'])) {
            $order_id = $this->request->get['order_id'];
        } else {
            $order_id = 0;
        }
        $checkApiKey = $this->model_browntape_order->checkApiKey($this->request->get['apikey']);
        # -- End $_GET params --------------------------
        if ($checkApiKey) {
            $status = $this->model_browntape_order->updateOrderStatus($order_id, 7);
            if ($status == 1) {
                $json['status'] = array(
                    'order_status' => 'Cancelled'
                );
            } else {
                $json = array(
                    'success' => true,
                    'Error' => 'order id not found',
                    'order_status' => ''
                );
            }
            $this->response->setOutput(json_encode($json, true));
        } else {
            $json = array(
                'success' => true,
                'Error' => array(
                    $this->message
                )
            );
            $this->response->setOutput(json_encode($json));
        }
    }
    /*this function update order status */
    public function _changeProductStock() {
        $this->load->model('browntape/order');
        $this->load->model('tool/image');
        $json = array(
            'success' => true
        );
        # -- $_GET params ------------------------------
        if (isset($this->request->get['sku'])) {
            $sku = $this->request->get['sku'];
        } else {
            $sku = '';
        }
        if (isset($this->request->get['quantity'])) {
            $quantity = $this->request->get['quantity'];
        } else {
            $quantity = 1;
        }
        $checkApiKey = $this->model_browntape_order->checkApiKey($this->request->get['apikey']);
        # -- End $_GET params --------------------------
        if ($checkApiKey) {
            $status = $this->model_browntape_order->changeProductStock($sku, $quantity);
            if ($status == 1) {
                $json['products'] = array(
                    'product_status' => 'product quantity change by ' . $quantity
                );
            } else {
                $json['products'] = array(
                    'Error' => 'product not found',
                    'product_status' => ''
                );
            }
            $this->response->setOutput(json_encode($json, true));
        } else {
            $json = array(
                'success' => true,
                'Error' => array(
                    $this->message
                )
            );
            $this->response->setOutput(json_encode($json));
        }
    }
    public function _getorderlist() {
        $this->load->model('browntape/order');
        $this->load->model('tool/image');
        $json = array(
            'success' => true,
            'ordercount' => 0,
            'orders' => array()
        );
        # -- $_GET params ------------------------------
        if (isset($this->request->get['startDate'])) {
            $startDate = $this->request->get['startDate'];
        } else {
            $startDate = null;
        }
        $checkApiKey = $this->model_browntape_order->checkApiKey($this->request->get['apikey']);
        # -- End $_GET params --------------------------
        if ($checkApiKey) {
            if ($startDate == null)
                $json['Error'] = "startDate date must not be NULL";
            else {
                $orders = $this->model_browntape_order->getOrders(array(
                    'startDate' => $startDate
                ));
                
                foreach ($orders as $order) {
                    $json['orders'][] = array(
                        'order_id' => $order['order_id'],
                        'invoice_no' => $order['invoice_no'],
                        'invoice_prefix' => $order['invoice_prefix'],
                        'store_id' => $order['store_id'],
                        'store_name' => $order['store_name'],
                        'store_url' => $order['store_url'],
                        'customer_id' => $order['customer_id'],
                        'customer_group_id' => $order['customer_group_id'],
                        'firstname' => $order['firstname'],
                        'lastname' => $order['lastname'],
                        'email' => $order['email'],
                        'telephone' => $order['telephone'],
                        'fax' => $order['fax'],
                        'payment_firstname' => $order['payment_firstname'],
                        'payment_lastname' => $order['payment_lastname'],
                        'payment_company' => $order['payment_company'],
                        'payment_company_id' => @$order['payment_company_id'],
                        'payment_tax_id' => @$order['payment_tax_id'],
                        'payment_address_1' => $order['payment_address_1'],
                        'payment_address_2' => $order['payment_address_2'],
                        'payment_city' => $order['payment_city'],
                        'payment_postcode' => $order['payment_postcode'],
                        'payment_country' => $order['payment_country'],
                        'payment_country_id' => $order['payment_country_id'],
                        'payment_zone' => $order['payment_zone'],
                        'payment_zone_id' => $order['payment_zone_id'],
                        'payment_address_format' => $order['payment_address_format'],
                        'payment_method' => $order['payment_method'],
                        'payment_code' => $order['payment_code'],
                        'shipping_firstname' => $order['shipping_firstname'],
                        'shipping_lastname' => $order['shipping_lastname'],
                        'shipping_company' => $order['shipping_company'],
                        'shipping_address_1' => $order['shipping_address_1'],
                        'shipping_address_2' => $order['shipping_address_2'],
                        'shipping_city' => $order['shipping_city'],
                        'shipping_postcode' => $order['shipping_postcode'],
                        'shipping_country' => $order['shipping_country'],
                        'shipping_country_id' => $order['shipping_country_id'],
                        'shipping_zone' => $order['shipping_zone'],
                        'shipping_zone_id' => $order['shipping_zone_id'],
                        'shipping_address_format' => $order['shipping_address_format'],
                        'shipping_method' => $order['shipping_method'],
                        'shipping_code' => $order['shipping_code'],
                        'comment' => $order['comment'],
                        'total' => $order['total'],
                        'order_status_id' => $order['order_status_id'],
                        'affiliate_id' => $order['affiliate_id'],
                        'commission' => $order['commission'],
                        'language_id' => $order['language_id'],
                        'currency_id' => $order['currency_id'],
                        'currency_code' => $order['currency_code'],
                        'currency_value' => $order['currency_value'],
                        'ip' => $order['ip'],
                        'forwarded_ip' => $order['forwarded_ip'],
                        'user_agent' => $order['user_agent'],
                        'accept_language' => $order['accept_language'],
                        'date_added' => $order['date_added'],
                        'shipping_fee' => (isset($order['shipping_fee']) ? $order['shipping_fee'] : NULL),
			'cod_fee' => (isset($order['cod_fee']) ? $order['cod_fee'] : NULL),
                        'date_modified' => $order['date_modified'],
                        'item' => $order['item']
                    );
                }
            }
            $json['ordercount'] = count($json['orders']);
            $this->response->setOutput(json_encode($json));
        } else {
            $json = array(
                'success' => true,
                'Error' => array(
                    $this->message
                )
            );
            $this->response->setOutput(json_encode($json));
        }
    }
}
?>

