<?php
class ModelBrowntapeOrder extends Model {
    public function getProduct($product_id) {
        $customer_group_id = $this->config->get('config_customer_group_id');
        $query             = $this->db->query("SELECT DISTINCT *, pd.name AS name, p.image, m.name AS manufacturer, (SELECT price FROM " . DB_PREFIX . "product_discount pd2 WHERE pd2.product_id = p.product_id AND pd2.customer_group_id = '" . (int) $customer_group_id . "' AND pd2.quantity = '1' AND ((pd2.date_start = '0000-00-00' OR pd2.date_start < NOW()) AND (pd2.date_end = '0000-00-00' OR pd2.date_end > NOW())) ORDER BY pd2.priority ASC, pd2.price ASC LIMIT 1) AS discount, (SELECT price FROM " . DB_PREFIX . "product_special ps WHERE ps.product_id = p.product_id AND ps.customer_group_id = '" . (int) $customer_group_id . "' AND ((ps.date_start = '0000-00-00' OR ps.date_start < NOW()) AND (ps.date_end = '0000-00-00' OR ps.date_end > NOW())) ORDER BY ps.priority ASC, ps.price ASC LIMIT 1) AS special, (SELECT points FROM " . DB_PREFIX . "product_reward pr WHERE pr.product_id = p.product_id AND customer_group_id = '" . (int) $customer_group_id . "') AS reward, (SELECT ss.name FROM " . DB_PREFIX . "stock_status ss WHERE ss.stock_status_id = p.stock_status_id AND ss.language_id = '" . (int) $this->config->get('config_language_id') . "') AS stock_status, (SELECT wcd.unit FROM " . DB_PREFIX . "weight_class_description wcd WHERE p.weight_class_id = wcd.weight_class_id AND wcd.language_id = '" . (int) $this->config->get('config_language_id') . "') AS weight_class, (SELECT lcd.unit FROM " . DB_PREFIX . "length_class_description lcd WHERE p.length_class_id = lcd.length_class_id AND lcd.language_id = '" . (int) $this->config->get('config_language_id') . "') AS length_class, (SELECT AVG(rating) AS total FROM " . DB_PREFIX . "review r1 WHERE r1.product_id = p.product_id AND r1.status = '1' GROUP BY r1.product_id) AS rating, (SELECT COUNT(*) AS total FROM " . DB_PREFIX . "review r2 WHERE r2.product_id = p.product_id AND r2.status = '1' GROUP BY r2.product_id) AS reviews, p.sort_order FROM " . DB_PREFIX . "product p LEFT JOIN " . DB_PREFIX . "product_description pd ON (p.product_id = pd.product_id) LEFT JOIN " . DB_PREFIX . "product_to_store p2s ON (p.product_id = p2s.product_id) LEFT JOIN " . DB_PREFIX . "manufacturer m ON (p.manufacturer_id = m.manufacturer_id) WHERE p.product_id = '" . (int) $product_id . "' AND pd.language_id = '" . (int) $this->config->get('config_language_id') . "' AND p.status = '1' AND p.date_available <= NOW() AND p2s.store_id = '" . (int) $this->config->get('config_store_id') . "'");
        $product_option = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "product_option_value  pov LEFT JOIN " . DB_PREFIX . "option_value_description ovd ON (ovd.option_value_id = pov.option_value_id) WHERE pov.product_id = '" . (int) $product_id . "'");
        if ($product_option->num_rows > 0) {
            $product_option_data = $product_option->rows;
        } else {
            $product_option_data = null;
        }
        if ($query->num_rows) {
            return array(
                'product_id' => $query->row['product_id'],
                'name' => $query->row['name'],
                'description' => $query->row['description'],
                'meta_description' => $query->row['meta_description'],
                'meta_keyword' => $query->row['meta_keyword'],
                'tag' => isset($query->row['tag']) ? $query->row['tag'] : "",
                'model' => isset($query->row['model']) ? $query->row['model'] : "",
                'sku' => @$query->row['sku'],
                'upc' => @$query->row['upc'],
                'ean' => isset($query->row['ean']) ? $query->row['ean'] : "",
                'jan' => isset($query->row['jan']) ? $query->row['jan'] : "",
                'isbn' => isset($query->row['isbn']) ? $query->row['isbn'] : "",
                'mpn' => isset($query->row['mpn']) ? $query->row['mpn'] : "",
                'location' => $query->row['location'],
                'quantity' => $query->row['quantity'],
                'stock_status' => $query->row['stock_status'],
                'image' => $query->row['image'],
                'manufacturer_id' => $query->row['manufacturer_id'],
                'manufacturer' => $query->row['manufacturer'],
                'price' => ($query->row['discount'] ? $query->row['discount'] : $query->row['price']),
                'special' => $query->row['special'],
                'reward' => $query->row['reward'],
                'points' => $query->row['points'],
                'tax_class_id' => $query->row['tax_class_id'],
                'date_available' => $query->row['date_available'],
                'weight' => $query->row['weight'],
                'weight_class_id' => $query->row['weight_class_id'],
                'length' => $query->row['length'],
                'width' => $query->row['width'],
                'height' => $query->row['height'],
                'length_class_id' => $query->row['length_class_id'],
                'subtract' => $query->row['subtract'],
                'rating' => round($query->row['rating']),
                'reviews' => $query->row['reviews'],
                'minimum' => $query->row['minimum'],
                'sort_order' => $query->row['sort_order'],
                'status' => $query->row['status'],
                'date_added' => $query->row['date_added'],
                'date_modified' => $query->row['date_modified'],
                'viewed' => $query->row['viewed'],
                'product_option' => $product_option_data
            );
        } else {
            return false;
        }
    }
    public function getProducts($data = array()) {
        
        if(!empty($data['startDate'])) {
            $sql = "SELECT product_id FROM `" . DB_PREFIX . "product` WHERE date_added >= '" . $data['startDate'] . "' AND status = '1'";
        } else {
            $sql = "SELECT product_id FROM `" . DB_PREFIX . "product` WHERE  status ='1'";
        }
        $product_data = array();
        
        if(isset($data['page'])){
            if(!empty($data['page'])){
                $items_per_page=500;   
                $offset = ($data['page'] - 1) * $items_per_page;
                $sql=$sql." LIMIT $offset,$items_per_page";
            }
        }
        $query        = $this->db->query($sql);
        if($query->num_rows>0){
            foreach ($query->rows as $result) {
                $product = $this->getProduct($result['product_id']);
                if ($product['product_id'] != null) {
                    $product_data[$result['product_id']] = $this->getProduct($result['product_id']);
                }
            }
        }
        return $product_data;
    }
    public function updateOrderStatus($orderId, $statusId, $couriername = null, $awbNo = null) {
        $sql   = "SELECT order_id FROM `" . DB_PREFIX . "order` WHERE order_id ='" . $orderId . "'";
        $query = $this->db->query($sql);
        if ($query->num_rows) {
            $this->db->query("INSERT INTO `" . DB_PREFIX . "order_history` (`order_id`, `order_status_id`, `notify`, `comment`, `date_added`)
				VALUES (" . (int) $orderId . ", " . (int) $statusId . ", 1, '', NOW())");
            if (!empty($couriername) && !empty($awbNo)) {
                $this->db->query("UPDATE " . DB_PREFIX . "`order` SET `order_status_id`= '" . (int) $statusId . "', `shipping_code` = '" . $awbNo . "', `shipping_method` = '" . $couriername . "' WHERE `order_id`= '" . (int) $orderId . "'");
            } else {
                $this->db->query("UPDATE `" . DB_PREFIX . "order` SET `order_status_id` = " . (int) $statusId . " WHERE `order_id` = " . (int) $orderId);
            }
            return 1;
        } else {
            return 0; //order id not found
        }
    }
    public function changeProductStock($sku, $qunty,$isChild=false) {
        if(!$isChild){
            $sql       = "SELECT * FROM `" . DB_PREFIX . "product` WHERE product_id='" . $sku . "'";
            $query     = $this->db->query($sql);
            if($query->num_rows>0) {
                $this->db->query("UPDATE " . DB_PREFIX . "product SET quantity = " . (int) $qunty . " WHERE product_id= '" . $sku . "'");
                return 1;
            }
        }else{
            $sql = "SELECT * FROM `" . DB_PREFIX . "product_option_value` WHERE product_option_value_id='" . $sku . "'";
            $query= $this->db->query($sql);
            if ($query->num_rows>0) {
               $this->db->query("UPDATE " . DB_PREFIX . "product_option_value SET quantity = " . (int) $qunty . " WHERE product_option_value_id= '" . $sku . "'");
                return 1;
            }
        }
        return 0;
    }
    public function getOrder($order_id) {
        $query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "order` WHERE order_id = '" . $order_id . "'");
        if ($query->num_rows) {
            $orderInfo         = array(
                'order_id' => $query->row['order_id'],
                'invoice_no' => $query->row['invoice_no'],
                'invoice_prefix' => $query->row['invoice_prefix'],
                'store_id' => $query->row['store_id'],
                'store_name' => $query->row['store_name'],
                'store_url' => $query->row['store_url'],
                'customer_id' => $query->row['customer_id'],
                'customer_group_id' => $query->row['customer_group_id'],
                'firstname' => $query->row['firstname'],
                'lastname' => $query->row['lastname'],
                'email' => $query->row['email'],
                'telephone' => $query->row['telephone'],
                'fax' => $query->row['fax'],
                'payment_firstname' => $query->row['payment_firstname'],
                'payment_lastname' => $query->row['payment_lastname'],
                'payment_company' => $query->row['payment_company'],
                'payment_company_id' => $query->row['payment_company_id'],
                'payment_tax_id' => $query->row['payment_tax_id'],
                'payment_address_1' => $query->row['payment_address_1'],
                'payment_address_2' => $query->row['payment_address_2'],
                'payment_city' => @$query->row['payment_city'],
                'payment_postcode' => @$query->row['payment_postcode'],
                'payment_country' => @$query->row['payment_country'],
                'payment_country_id' =>@ $query->row['payment_country_id'],
                'payment_zone' => @$query->row['payment_zone'],
                'payment_zone_id' => @$query->row['payment_zone_id'],
                'payment_address_format' => $query->row['payment_address_format'],
                'payment_method' => @$query->row['payment_method'],
                'payment_code' => $query->row['payment_code'],
                'shipping_firstname' => $query->row['shipping_firstname'],
                'shipping_lastname' => $query->row['shipping_lastname'],
                'shipping_company' => $query->row['shipping_company'],
                'shipping_address_1' => $query->row['shipping_address_1'],
                'shipping_address_2' => $query->row['shipping_address_2'],
                'shipping_city' => $query->row['shipping_city'],
                'shipping_postcode' => $query->row['shipping_postcode'],
                'shipping_country' => $query->row['shipping_country'],
                'shipping_country_id' => $query->row['shipping_country_id'],
                'shipping_zone' => $query->row['shipping_zone'],
                'shipping_zone_id' => $query->row['shipping_zone_id'],
                'shipping_address_format' => $query->row['shipping_address_format'],
                'shipping_method' => $query->row['shipping_method'],
                'shipping_code' => $query->row['shipping_code'],
                'comment' => $query->row['comment'],
                'total' => $query->row['total'],
                'order_status_id' =>$this->getOrderStatus($query->row['order_status_id']),
                'affiliate_id' => $query->row['affiliate_id'],
                'commission' => $query->row['commission'],
                'language_id' => $query->row['language_id'],
                'currency_id' => $query->row['currency_id'],
                'currency_code' => $query->row['currency_code'],
                'currency_value' => $query->row['currency_value'],
                'ip' => $query->row['ip'],
                'forwarded_ip' => $query->row['forwarded_ip'],
                'user_agent' => $query->row['user_agent'],
                'accept_language' => $query->row['accept_language'],
                'date_added' => $query->row['date_added'],
                'date_modified' => $query->row['date_modified']
            );
            $item              = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "order_product  WHERE order_id = '" . (int) $order_id . "'");
            $orderInfo['item'] = $item->rows;
            foreach ($item->rows as $key => $it) {
                 $itemOption              = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "order_option  WHERE order_product_id = '" . (int) $it['order_product_id'] . "'");

                if($itemOption->num_rows>0){
                    $productOption              = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "product_option_value  WHERE product_option_value_id = '" . (int) $itemOption->row['product_option_value_id'] . "'");
                      $orderInfo['item'][$key]['product_option_value_id']=$itemOption->row['product_option_value_id'];
                     if($productOption->num_rows>0)
                        $orderInfo['item'][$key]['sku'] = (isset($productOption->row['sku'])?$productOption->row['sku']:'');
                
                }else{
                    $product_sku                    = $this->getProduct($it['product_id']);
                    $orderInfo['item'][$key]['sku'] = $product_sku['sku'];
                      $orderInfo['item'][$key]['product_option_value_id']=null;
                }
            }
            $shipping_fee              = $this->db->query("SELECT DISTINCT * FROM " . DB_PREFIX . "order_total  WHERE order_id = '" . (int) $order_id . "'");
            $orderInfo['shipping_fee']=NULL;
            if($shipping_fee->num_rows){
                foreach($shipping_fee->rows as $row){
		    	if($row['code']=='shipping'){
		        	$orderInfo['shipping_fee'] = $row['value'];
		    	}
			if($row['code'] == 'cod_fee'){
				$orderInfo['cod_fee'] = $row['value'];	
			}
                }
            }
            return $orderInfo;
        } else {
            return false;
        }
    }
    public function getOrders($data = array()) {
        if (!empty($data['startDate'])) {
            $sql = "SELECT * FROM `" . DB_PREFIX . "order` WHERE date_added >= '" . $data['startDate'] . "' AND order_status_id != '0'";
        } else {
            $sql = " SELECT * FROM " . DB_PREFIX . "`order` WHERE order_status_id != '0'";
        }
        $query      = $this->db->query($sql);
        $order_data = array();
        foreach ($query->rows as $result) {
            $order_data[$result['order_id']] = $this->getOrder($result['order_id']);
        }
        return $order_data;
    }
    public function checkApiKey($apikey) {
        $user = $this->db->query("SELECT * FROM `" . DB_PREFIX . "api` WHERE api = '" . $apikey . "' AND flag=1");
        if (($user->num_rows)) {
            return true;
        } else {
            return false;
        }
    }
    /*Get Order Status*/
     private function getOrderStatus($order_status_id) {
        $orderStatus = $this->db->query("SELECT name FROM `" . DB_PREFIX . "order_status` WHERE order_status_id = '" . $order_status_id . "'");
        if (($orderStatus->num_rows)) {
            return $orderStatus->row['name'];
        } else {
            return null;
        }
    }
}
?>
